var _cardioLogAgentRoot = "<%= cardioLogAgentRoot %>";
var _env = "<%= env %>";
var _agentEnvironmentVersion = "<%= agentEnvironmentVersion %>";
var _serverTime = "<%= serverTime %>";
var _useSPAuth = "<%= UseSPAuth %>";

var _loadSpUserOnClient = false;
if (_useSPAuth || _env == "SP2013" || _env == "SPOnline")
{   //when env is 2013 or online pass the user on event - for annonymous access on server side
    _loadSpUserOnClient = true;
}

var __IE = { is:(navigator.userAgent.indexOf("MSIE")>-1)};
__IE.ver = (__IE.is) ? parseInt(navigator.userAgent.match(/MSIE [0-9]+/g).toString().split(" ")[1]) : null;
document.BrowserType = (__IE.is) ? "ie" : "non-ie";

// AGENT EMBED
var element = {};
//Use this format: element\.[a-zA-Z0-9_]+
document.__campaignkeys = {"campaign":"ca_campaign", "source":"ca_source", "medium":"ca_medium", "content":"ca_content", "term":"ca_term"};
document.__refstoignore = "";

var __aeLogger = {
	// function __log(value, module, severity)
	log: function(value, module, severity)
	{
		value = (new Date()).toTimeString().replace(/ .*/, "")+" "+value;
		if (element.verbose || module == "events") {
			if (typeof(_cal) != "undefined") _cal.push([module || 'agent', severity, value]);
			else if (typeof(console) != "undefined") console.info(value+","+document.location.href);
		}
		if (element.verbose && typeof(console) != "undefined" && typeof(console[severity]) != "undefined") console[severity](new Date()+","+value+","+document.location.href);
	},
	// function __error(value, module)
	error: function(value, module)
	{
		this.log(value, module, 'error');
	},
	// function __trace(value, module)
	trace: function(value, module)
	{
		this.log(value, module, 'info');
	}
}

var __aeCookieHandler = {
	// __saveCookie(name, value, days, domain)
	SaveCookie: function(name, value, days, domain)
	{
		__aeLogger.trace("__aeCookieHandler.SaveCookie('"+name+"','"+value+"',"+days+");");
		if (days) {
			//var date = new Date();
			var date = getServerDate();
			date.setTime(date.getTime()+(days*24*60*60*1000))
			var expires = "; expires="+date.toGMTString()
		} else expires = "";
		var dom = (domain) ? ";domain="+domain : "";
		document.cookie = name+"="+encodeURIComponent(value)+expires+dom+";path=/";
	},
	//function __readCookie(name)
	ReadCookie: function(name)
	{
		__aeLogger.trace("__aeCookieHandler.ReadCookie('"+name+"');");
		name += "=";
		var cookieArr = document.cookie.split(';');
		for (var i=0;i<cookieArr.length;i++) {
			var c = cookieArr[i];
			while (c.substring(0,1) == ' ') c = c.substring(1, c.length)
			if (c.indexOf(name) == 0) return decodeURIComponent(c.substring(name.length, c.length))
		}
		return null;
	},
	//function __deleteCookie(name)
	DeleteCookie: function(name)
	{
		__aeLogger.trace("__aeCookieHandler.DeleteCookie('"+name+"');");
		this.SaveCookie(name, "", -1)
	}
}


element.EventCollectorPath = "";
element.version = "1.19.158.1";
element.AgentName = _env + " Agent";
element.TunnelPath = _cardioLogAgentRoot + "/CardioLogAgent/tunnel.aspx";
element.UserPath = _cardioLogAgentRoot + "/CardioLogAgent/caUser.aspx";
element.AgentDirectory = _cardioLogAgentRoot + "/CardioLogAgent";
element.HelpletFile = "";
element.Event_Visit = true;
element.Event_Leave = true;
element.Event_Search = true;
element.Event_SearchResultItem = false;
element.Event_SearchResultClick = true;
element.HelpletsEnabled = false;
element.Greedy = true;
element.MaxDuration = "1800000";
element.RefreshPeriod = "1";
element.SearchPeriod = "10";
element.SupportAnonymousUsers = true;
element.HandleFileExtension = true;
element.EnableConsole = true;
element.AgentEnvironmentVersion = _agentEnvironmentVersion;
element.AgentEnvironment = _env;
element.BrowserType = "";
element.Param3ElementName = "";
element.verbose = ((__aeCookieHandler.ReadCookie('_caverbose') || 'false') == 'true');
element.ClientServerTimeDifference = _serverTime - new Date().getTime();
element.EnableAltKey = true;
element.GetReferrerData = true;
element.Ping = true;
element.EnableClientTimestamp = false;
element.SessionTimer = 30; // Renew session (in minutes)
element.CookieDomain = (document.domain.match(/\.[^/]+/)!=null) ? document.domain.match(/\.[^/]+/)[0] : null;
element.wait4CA = true;
element.document = window.document;
var _cal = _cal || [];


// Top level domains
// Find a fix that works for a random TLD. Custom TLDs (Like .xl) do not work with this solution without manually adding them to the list
var tlds = ["# Version 2013111200, Last Updated Tue Nov 12 07:07:01 2013 UTC","AC","AD","AE","AERO","AF","AG","AI","AL","AM","AN","AO","AQ","AR","ARPA","AS","ASIA","AT","AU","AW","AX","AZ","BA","BB","BD","BE","BF","BG","BH","BI","BIZ","BJ","BM","BN","BO","BR","BS","BT","BV","BW","BY","BZ","CA","CAMERA","CAT","CC","CD","CF","CG","CH","CI","CK","CL","CLOTHING","CM","CN","CO","COM","COOP","CR","CU","CV","CW","CX","CY","CZ","DE","DJ","DK","DM","DO","DZ","EC","EDU","EE","EG","EQUIPMENT","ER","ES","ET","EU","FI","FJ","FK","FM","FO","FR","GA","GB","GD","GE","GF","GG","GH","GI","GL","GM","GN","GOV","GP","GQ","GR","GS","GT","GU","GURU","GW","GY","HK","HM","HN","HOLDINGS","HR","HT","HU","ID","IE","IL","IM","IN","INFO","INT","IO","IQ","IR","IS","IT","JE","JM","JO","JOBS","JP","KE","KG","KH","KI","KM","KN","KP","KR","KW","KY","KZ","LA","LB","LC","LI","LIGHTING","LK","LR","LS","LT","LU","LV","LY","MA","MC","MD","ME","MG","MH","MIL","MK","ML","MM","MN","MO","MOBI","MP","MQ","MR","MS","MT","MU","MUSEUM","MV","MW","MX","MY","MZ","NA","NAME","NC","NE","NET","NF","NG","NI","NL","NO","NP","NR","NU","NZ","OM","ORG","PA","PE","PF","PG","PH","PK","PL","PM","PN","POST","PR","PRO","PS","PT","PW","PY","QA","RE","RO","RS","RU","RW","SA","SB","SC","SD","SE","SG","SH","SI","SINGLES","SJ","SK","SL","SM","SN","SO","SR","ST","SU","SV","SX","SY","SZ","TC","TD","TEL","TF","TG","TH","TJ","TK","TL","TM","TN","TO","TP","TR","TRAVEL","TT","TV","TW","TZ","UA","UG","UK","US","UY","UZ","VA","VC","VE","VENTURES","VG","VI","VN","VOYAGE","VU","WF","WS","XN--3E0B707E","XN--45BRJ9C","XN--80AO21A","XN--80ASEHDB","XN--80ASWG","XN--90A3AC","XN--CLCHC0EA0B2G2A9GCD","XN--FIQS8S","XN--FIQZ9S","XN--FPCRJ9C3D","XN--FZC2C9E2C","XN--GECRJ9C","XN--H2BRJ9C","XN--J1AMH","XN--J6W193G","XN--KPRW13D","XN--KPRY57D","XN--L1ACC","XN--LGBBAT1AD8J","XN--MGB9AWBF","XN--MGBA3A4F16A","XN--MGBAAM7A8H","XN--MGBAYH7GPA","XN--MGBBH1A71E","XN--MGBC0A9AZCG","XN--MGBERP4A5D4AR","XN--MGBX4CD0AB","XN--NGBC5AZD","XN--O3CW4H","XN--OGBPF8FL","XN--P1AI","XN--PGBS0DH","XN--S9BRJ9C","XN--UNUP4Y","XN--WGBH1C","XN--WGBL6A","XN--XKC2AL3HYE2A","XN--XKC2DL3A5EE0H","XN--YFRO4I67O","XN--YGBI2AMMX","XXX","YE","YT","ZA","ZM","ZW", "XL"];

for(var key in tlds){
if(key == "indexOf")
continue;
	if(typeof tlds[key] != "function" && "."+tlds[key].toLowerCase() === element.CookieDomain )
	{
		element.CookieDomain = window.location.host;
	}
}

var __alreadyLoaded = false;

function __init() {
	if (__alreadyLoaded) return;
	(document.attachEvent) ? document.attachEvent("onkeydown", keydownmain) : document.addEventListener("keydown", keydownmain, false);
	__alreadyLoaded = true;
}

<%= GetUserNameCustom %>


//GetUsername/*  
function GetUsername(callback) {
	__aeLogger.trace("GetUsername");

	var useridInput = this.document.getElementById("userid");
    if (useridInput && useridInput.value != "")
    {
		currentUsername = useridInput.value;
    }
    else
    {
        if (typeof(_spPageContextInfo) !=  "undefined"  && _spPageContextInfo.userLoginName !=  "undefined" && _spPageContextInfo.userLoginName){
            callback (_spPageContextInfo.userLoginName);
            return;
        }

        var currentUsername = __aeCookieHandler.ReadCookie("_userid");
        var currentUserId = __aeCookieHandler.ReadCookie("spUserid");
        if (typeof(_spPageContextInfo) !=  "undefined" )
        {
            if (!currentUserId || currentUserId != _spPageContextInfo.userId)
            {
                currentUsername = null;  
                __aeCookieHandler.SaveCookie("spUserid", _spPageContextInfo.userId, 1000, element.CookieDomain);
            }
        }
	    
        if (!currentUsername)
        {
            if (_loadSpUserOnClient && typeof (getSPUserAccount) != "undefined")
            {
                getSPUserAccount(function (userName)
                {
                    if (!userName){
                        userName = "Anonymous_"+Math.random()*100000;
                    }

                	__aeCookieHandler.SaveCookie("_userid", userName, 1000, element.CookieDomain);
                	__aeLogger.trace("GetUsername return: "+userName);

                    callback (userName);
                });
                return;
            }
            else
            {
		        currentUsername = "Anonymous_"+Math.random()*100000;
            }
        }
        __aeCookieHandler.SaveCookie("_userid", currentUsername, 1000, element.CookieDomain);
    }
	
    __aeLogger.trace("GetUsername return: "+currentUsername);

    callback (currentUsername);
}
//GetUsername*/ 

function GetParam3ElementValue() {
	__aeLogger.trace("GetParam3ElementValue");
	var currentParam3 = __aeCookieHandler.ReadCookie("param3");
	var param3Input = this.document.getElementById(element.Param3ElementName);
	if (param3Input)
		currentParam3 = param3Input.value;

	__aeCookieHandler.SaveCookie("param3", currentParam3, 1000, element.CookieDomain);
	__aeLogger.trace("GetParam3ElementValue return: "+currentParam3);
	return currentParam3;
}

function keydownmain(e) {
	e = (e) ? e : event;
	if ((typeof(element["EnableConsole"]) == "undefined" || element.EnableConsole) && (e.ctrlKey || e.altKey) && e.keyCode == 121) printDebug();
    else if ((typeof(element["EnableConsole"]) == "undefined" || element.EnableConsole) && (e.ctrlKey) && e.keyCode == 123) __Page.showConsole();
	else if ((typeof(element["EnableConsole"]) == "undefined" || element.EnableConsole) && (typeof(element["EnableAltKey"]) == "undefined" || element.EnableAltKey) && e.altKey && e.keyCode == 123) __Page.showConsole();
}
function printDebug() {
    var output = ""; for (var i=0;i<__Status.output.length;i++) { output += __Status.output[i].o+"\n";} prompt("", output);;
}
__init();

// AGENT REFERRER <<-----!!
var __Referreragent = {	url: document.location.href, ignoreref: false, loaded: false, medium: "direct", source: "", term: "", campaign: "",	content: "", sites: [], adsensedomains: [], refs: [], site: document.referrer};
__Referreragent.campaignkeys = { "campaign":"utm_campaign", "source":"utm_source", "medium":"utm_medium", "content":"utm_content", "term":"utm_term"};
__Referreragent.GetReferrer = function() {
    if (!this.loaded) this.init();
	return this;
}
__Referreragent.CreateReferrer = function(source, medium, campaign, term, content) {
	this.source = source; this.medium = medium; this.campaign = campaign; this.term = term; this.content = content; this.loaded = true;
	return this;
}
__Referreragent.ToString = function(debug) {
    if (!this.loaded) this.init();
    if (debug) return "medium:"+this.medium + "|source:" + this.source + "|term:" + this.term + "|campaign:" + this.campaign + "|content:" + this.content;
    else return this.medium+"|"+this.source+"|"+this.term+"|"+this.campaign+"|"+this.content;
}
__Referreragent.init = function() {
    var url = document.location.href;
    var c = __Referreragent._getSearch();
    if (c != null) {
	    var se = this._isAdsense(c.source);
	    if (se) {
	        c.medium = "adsense";
	        c.source = se;
	        var i = decodeURIComponent(c.term).match(/http[s]?\:\/\/([^\/]*)([^\?]*)/i);
	        if (i != null) {
				this.source = c.source;
				this.content = i[1] || "";
				this.term = i[2] || ""
			} else {
		        this.source = c.source;
		        this.term = c.term;
		    }
	    } else {
	       	var _url = decodeURIComponent(url);
	        c.medium = (_url.match(/[&?]gclid=/) || document.referrer.match(/[&?]adurl=/)) ? "cpc" : "organic";
	        this.source = c.source;
	        this.term = c.term;
	        this.content = c.content;
	    }
        this.medium = c.medium
    }
    var c = this._getCampaign();
    if (c != null) {
        this.source = c.source || this.source;
        this.term = c.term || this.term;
        this.medium = c.medium || "";
        this.content = c.content || this.content;
        this.campaign = c.campaign || this.campaign;
        return;
    } else {
		var r = this._getReferrer();
		if (r != null) {
			this.source = this.source == "" ? r.source : this.source;
			if (decodeURIComponent(url).match(/[&?]gclid=/)) {
				this.medium = this.medium || "cpc";
				this.source = this.source || "google";
			}
			if (this.source == "") {
				this.ignoreref = true;
				return;
			}
			this.content = this.content == "" ? r.content : this.content;
			this.medium = this.medium == "direct" ? "referral" : this.medium;
			this.term = this.term == "" ? r.term : this.term;
		} else {
			this.ignoreref = true;
		}
	}
}

__Referreragent._getParam = function(name) {
    var re = new RegExp("[&\\\?]"+name+"=([^&]*)", "i");
    var m = document.location.search.match(re);
    return (m != null) ? m[1] : "";
}
__Referreragent._getReferrer = function() {
    var r = document.referrer;
    if (r == "") return null;

	if (document.__refstoignore) __Referreragent._addIgnoredRefs(document.__refstoignore);
	if (this._extractReferrer(this.site)) return null;

    var o = {};
    var m = decodeURIComponent(r).match(/http[s]?\:\/\/([^\/]*)([^\?]*)/i);
    if (m != null) {
        o.source = m[1] || "";
        o.term = m[2] || "";
        o.content = "";
    }
    return (document.domain.match(o.source)) ? null : o;
}

__Referreragent.stripcampaignparams = function(u) {
	u = u.replace(/\^\^/g, "&");
    for (var i in this.campaignkeys) {
		var paramname = "";
		if (document.__campaignkeys && document.__campaignkeys.hasOwnProperty(i) && document.__campaignkeys[i] != "") paramname = document.__campaignkeys[i];
		else if (this.campaignkeys.hasOwnProperty(i)) paramname = this.campaignkeys[i];
		var re = new RegExp(paramname+"=[^\&]*[\&]?", "i");
		u = u.replace(re, "");
	}
	if (u.match(/[\&|\?]$/)) u = u.replace(/[\&|\?]$/,"");
	return u.replace(/\&/g, "^^");
}

__Referreragent._getCampaign = function() {
    var o = {};
    for (var i in this.campaignkeys) {
		var paramname = "";
		if (document.__campaignkeys && document.__campaignkeys.hasOwnProperty(i) && document.__campaignkeys[i] != "") paramname = document.__campaignkeys[i];
		else if (this.campaignkeys.hasOwnProperty(i)) paramname = this.campaignkeys[i];
		o[i] = this._getParam(paramname);
		var re = new RegExp(paramname+"=[^\&]*[\&]?", "i");
		this.url = this.url.replace(re, "");
	}

	if (this.url.match(/[\&|\?]$/)) this.url = this.url.replace(/[\&|\?]$/,"");

    return (o.medium != "" || o.source != "" || o.campaign != "" || o.term != "" || o.content != "") ? o : null;
}

__Referreragent._extractReferrer = function(url) {
    if (!url) return null;
    for (var m, i = this.refs.length-1; i >= 0; --i)  {
	    if (m = this.refs[i].exec(url)) return true;
    }
}

__Referreragent._extractSearch = function(url) {
    if (!url) return null;
    for (var m, i = this.sites.length-1; i >= 0; --i)  {
	    if (m = this.sites[i].exec(decodeURIComponent(url))) {
		    return {source:m[1], term:decodeURIComponent(m[2] == "" ? "not provided": m[2]), content:decodeURIComponent(url).match(/http[s]?\:\/\/([^\/]*)/i)[1]};
	    }
    }
}
__Referreragent._isAdsense = function (b) {
    for (var c = 0, d = this.adsensedomains.length; c < d; c++) {
        if (this.adsensedomains[c].d == b) {
            return this.adsensedomains[c].s
        }
    }
    return false;
}
__Referreragent._getSearch = function() {
    return this._extractSearch(this.site);
}

__Referreragent._addOrganic = function(domain, keyword, prepend) {
    if (prepend) this.sites.splice(0, 0, new RegExp("^http[s]?:\/\/[^\/]*?\\b("+domain+")(?:[^\/]*)\/.+?[\?&]"+keyword+"=([^&#]*)", "i"));
    else this.sites.push(new RegExp("^http[s]?:\/\/[^\/]*?\\b("+domain+")(?:[^\/]*)\/.+?[\?&]"+keyword+"=([^&#]*)", "i"));
}
__Referreragent._addIgnoredRef = function(domain, prepend) {
    if (prepend) this.refs.splice(0, 0, new RegExp("^http[s]?:\/\/[^\/]*?\\b("+domain+")", "i"));
    else this.refs.push(new RegExp("^http[s]?:\/\/[^\/]*?\\b("+domain+")", "i"));
}
__Referreragent._addOrganics = function(list) {
    var searches = list.split(",");
    for (var i=0;i<searches.length;i++) this._addOrganic(searches[i].split(":")[0], searches[i].split(":")[1]);
}
__Referreragent._addIgnoredRefs = function(list) {
    var refs = list.split(",");
    for (var i=0;i<refs.length;i++) this._addIgnoredRef(refs[i].replace(/http[s]?/,""));
}
__Referreragent._addAdsenses = function(list) {
    var h = list.split(",");
    for (var i = 0; i < h.length; i++) {
        var g = h[i].split(":");
        this._addOrganic(g[0], g[1], null);
        this.adsensedomains.push({
            d: g[0],
            s: g[2]
        })
    }
}
__Referreragent._addOrganics("daum:q,eniro:search_word,naver:query,images.google:q,google:q,yahoo:p,msn:q,bing:q,aol:query,aol:encquery,lycos:query,ask:q,altavista:q,netscape:query,cnn:query,about:terms,mamma:query,alltheweb:q,voila:rdata,virgilio:qs,live:q,baidu:wd,alice:qs,yandex:text,najdi:q,aol:q,mama:query,seznam:q,search:q,wp:szukaj,onet:qt,szukacz:q,yam:k,pchome:q,kvasir:q,sesam:q,ozu:q,terra:query,mynet:q,ekolay:q,rambler:words");
__Referreragent._addAdsenses("googleads.g.doubleclick.net:url:google");