SELECT
    AllDocs.Id as spid,
    AllDocs.SiteId as siteid,
    tp_version, 
    tp_modified, 
    tp_created, 
    tp_author,
    AllUserData.tp_Editor as tp_editor,
    size = isnull(AllUserData.tp_Size,0) + isnull(AllDocs.Size,0)+ isnull(AllDocs.MetaInfoSize,0)
FROM  
    AllUserData WITH (NOLOCK)
        INNER JOIN
    AllDocs WITH (NOLOCK) ON AllUserData.tp_DirName = AllDocs.DirName 
        AND AllUserData.tp_LeafName = AllDocs.LeafName 
        AND AllUserData.tp_SiteId = AllDocs.SiteId
WHERE
    tp_modified > '{0}'
    and tp_modified < getdate()
    and not(SUBSTRING(tp_contenttypeid, 1, 2) = 0x0101) 
    and not(tp_dirname LIKE N'%[_]catalogs%')
    and not(tp_dirname LIKE N'%Workflow History%')
    and not(tp_dirname LIKE N'%WorkflowHistory%')
    and not(tp_dirname LIKE N'%TaxonomyHiddenList%')
    and (tp_DeleteTransactionID = 0x)