﻿<%@ page language="C#" autoeventwireup="true" inherits="Designer_index, CardioLog_deploy" %>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <title>SEO</title>
    <meta name="description" content="ProjectName" />
    <meta name="keywords" content="ProjectName" />

    <link rel="stylesheet" type="text/css" media="screen,projection" href="/CardioLog/MarketingSuite/Assets/Styles/style.css" />
    <link href="/CardioLog/Styles/jquery.styledButton.css" rel="stylesheet" type="text/css" />
    <link rel="stylesheet" type="text/css" media="screen,projection" href="/CardioLog/MarketingSuite/SEO/Assets/css/style.css" />
    <script type="text/javascript" src="/CardioLog/MarketingSuite/Assets/Scripts/common.js"></script>
	<script type="text/javascript" src="/CardioLog/Scripts/jquery1.7.js"></script>
    <script type="text/javascript" src="/CardioLog/Scripts/jquery.json-2.2.js"></script>
    <script type="text/javascript" src="/CardioLog/MarketingSuite/SEO/Assets/js/jquery.wresize.js"></script>
    <script type="text/javascript" src="/CardioLog/MarketingSuite/Assets/Scripts/scripts.js"></script>
    <script type="text/javascript" src="/CardioLog/Scripts/jquery.styledButton.js"></script>

    
    <script type="text/javascript">
        // HELPER DATE COMPARE FUNCTION
        /* Compare the current date against another date.
        *
        * @param b  {Date} the other date
        * @returns   -1 : if this < b
        *             0 : if this === b
        *             1 : if this > b
        *            NaN : if a or b is an illegal date
        */
        Date.prototype.compare = function (b) {
            if (b.constructor !== Date) {
                throw "invalid_date";
            }
            return (isFinite(this.valueOf()) && isFinite(b.valueOf()) ?
          (this > b) - (this < b) : NaN
        );
        };

        function addSharepointFarm(spsVersion) {
            document.location = "SpsAdaptor.aspx?id=0&type=SharePoint " + spsVersion;
        }

    </script>
</head>
<body>
<form id="form1" runat="server">

<asp:HiddenField  ID="hdnReports" runat="server" />
<asp:HiddenField  ID="hdnData" runat="server" />

<div id="loader"><%=CardioLog.API.Localization.getText("$Loading$")%>...</div>
<div id="overlay"></div>
<div class="wrapper">
	<div class="section hasgradient">
		<div class="content">
			<!--innerbox -->
			<div class="innerbox">
				<!--SURVEYS -->
				<div class="title">
                    <%if (!exceedWidgetQuota()) { %>
					<div class="alignright" >
                        <div class="createAdaptorsCollection" style="width:130px; height:15px; margin-right:17px;"><span style="padding-left:20px;"><%=CardioLog.API.Localization.getText("$Add Widget$")%></span>
		                    <ul >
			                    <li onclick="addNewReport('MenuEntry');">Menu</li>
                                <li onclick="addNewReport('Chart');">Chart</li>
                                <li onclick="addNewReport('Table');">Table</li>
                                <li onclick="addNewReport('Meter')">Meter</li>
		                    </ul>
	                    </div>
                    </div>
                    <%} %>
				</div>
				<div class="surveytable seotable">
					<br />
					<table cellpadding="0" cellspacing="0" border="0" id="jobs">
						<thead>
							<tr>
								<th align="left" class="th-padd" style="padding-left:10px;"><%=CardioLog.API.Localization.getText("$Title$")%></th>
								<th align="left"><%=CardioLog.API.Localization.getText("$Type$")%></th>
                                <th align="left"><%=CardioLog.API.Localization.getText("$Description$")%></th>
								<th align="left"><%=CardioLog.API.Localization.getText("$Location$")%></th>
								<th>&nbsp;</th>
							</tr>
						</thead>
						<tbody id="jobstable">
						</tbody>
					</table>
				</div>
			</div>
		</div>
	</div>
</div>
<!-- /wrapper -->
<div class="overly" id="overly" style="display:none;"></div>

</form> 

<script type="text/javascript">
    var reports = null;
    var pagecaption = '<%=CardioLog.API.Localization.getText("$Custom Widgets$")%>';

    function addNewReport(type){
        window.location = "Widget.aspx?type=" + type;
    }

    function getmilliseconds(value) {
        value = value / (100 * 60 * 60);
        return lpad(Math.floor(value / 10)) + ":" + ((value % 10 == 5) ? "30" : "00");
    }
    function getschedule(obj) {
        var day = parseInt(obj.scheduledetails / 24 / 60 / 60 / 1000); // Sunday = 1
        var hourofday = obj.scheduledetails - day * 24 * 60 * 60 * 1000;
        var text = "Every " + ((obj.scheduletype == "2") ? "day" : days[parseInt(day, 10)]) + " at " + getmilliseconds(hourofday);
        return text;
    }

    function drawAdaptors() {
        var recheck = false;
        
        $("#jobstable > tr").remove();

        if (spsAdaptors.length == 0)
        	$("#jobs").hide();
        else
        	$("#jobs").show();

        for (var i = 0; i < spsAdaptors.length; i++) {
            var type = spsAdaptors[i].type + " " + spsAdaptors[i].version;
            var href = "SpsAdaptor.aspx?id=" + spsAdaptors[i].id + "&type=" + type; 
            $("#jobstable").append('<tr>' +
					'	<td><h3><a href="' + href + '">' + spsAdaptors[i].title + '</a></h3></td>' +
					'	<td>' + type + '</td>' +
                    '	<td>' + (spsAdaptors[i].db_server ? spsAdaptors[i].db_server : "(<%=CardioLog.API.Localization.getText("$None$")%>)") + '</td>' +
                    '	<td>' + formattimestamptodatetime(spsAdaptors[i].created) + '</td>' +
					'</tr>');
        }
        if (recheck) {
            window.setTimeout(reloadpage, 10000);
        }
    }

    function reloadpage() {
        var webflag = "";
        document.location.href = "index.aspx" + webflag;
    }

    $(window).load(function () {
        $("div.createAdaptorsCollection").styledButton({
            'padding': '5px 20px',
            'font-size': '14px',
            'orientation': 'left',
            'dropdown': { 'element': 'ul' },
            'role': 'select',
            'defaultValue': 'default value',
            'name': 'adaptors',
            'clear': true
        });

        reports = $.evalJSON($("#hdnReports").val());

        syncModelToView ();
    });

    parent.setCaption('Administration', false, pagecaption);


    function addReportRow(report) {
        var href = "Widget.aspx?id=" + report.ID + "&type=" + report.Type; /// + "&reportFile=" + report.File; 
        $("#jobstable").append('<tr>' +
				'	<td><h3><a href="' + href + '">' + report.Name + '</a></h3></td>' +
				'	<td>' + (report.Type == "MenuEntry" ? "Menu" : report.Type) + '</td>' +
                '	<td>' + (report.Description == "" ? "-" : report.Description) + '</td>' +
                '	<td>' + report.Location.DirectoryPath + '</td>' +
				'</tr>');
    }

    function syncModelToView() {

        for (var i = 0; i < reports.length; i++) {
            addReportRow(reports[i]);
        }

    }

    function init() {
        if (document.readyState != "complete") {
            window.setTimeout(init, 50);
            return;
        }

        reports = $.evalJSON($("#hdnReports").val());

        syncModelToView();
    }

    

    function onRemoveReports() {
        var removedReports = [];

        jQuery.each($('#reportsTable > tbody > tr > td > [checked]'), function () {
            removedReports.push($(this).attr("id").replace("deleteReport_", ""));
        });

        if (removedReports.length > 0) {
            $("#hdnData").val($.toJSON(removedReports));
            __doPostBack(null, 'removedReports');
        }

        return true;
    }


    //init();
    </script>

</body>
</html>