﻿<%@ page language="C#" autoeventwireup="true" inherits="MarketingSuite_SEO_SocialAdaptorList, CardioLog_deploy" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <title>SEO</title>
    <meta name="description" content="ProjectName" />
    <meta name="keywords" content="ProjectName" />

    <link rel="stylesheet" type="text/css" media="screen,projection" href="/CardioLog/MarketingSuite/Assets/Styles/style.css" />
    <link href="../../Styles/jquery.styledButton.css" rel="stylesheet" type="text/css" />
    <link rel="stylesheet" type="text/css" media="screen,projection" href="Assets/css/style.css" />
    <script type="text/javascript" src="/CardioLog/MarketingSuite/Assets/Scripts/common.js"></script>
	<script type="text/javascript" src="/CardioLog/Scripts/jquery1.7.js"></script>
    <script type="text/javascript" src="/CardioLog/Scripts/jquery.json-2.2.js"></script>
    <script type="text/javascript" src="Assets/js/jquery.wresize.js"></script>
    <script type="text/javascript" src="/CardioLog/MarketingSuite/Assets/Scripts/scripts.js"></script>
    <script type="text/javascript" src="/CardioLog/Scripts/jquery.styledButton.js"></script>

    <script type="text/javascript">

        function addYammerAdaptor() {
            var alreadyAdded = '<%=(alreadyAddedYammer())%>';

            if (alreadyAdded.toLowerCase() == 'true') {
                alert('<%=CardioLog.API.Localization.getText("$Yammer Adaptor already added.$")%>');
            }
            else {
                document.location = "YammerAdaptor.aspx";
            }
        }

        function addSitrionAdaptor() {
            var alreadyAdded = '<%=(alreadyAddedSitrion())%>';

            if (alreadyAdded.toLowerCase() == 'true') {
                alert('<%=CardioLog.API.Localization.getText("$Sitrion Adaptor already added.$")%>');
            }
            else {
                document.location = "SitrionAdaptor.aspx";
            }
        }

    </script>

</head>
<body>
    <form id="form1" runat="server">
    <asp:HiddenField ID="hdnAdaptors" Value="" runat="server" />
<div id="loader"><%=CardioLog.API.Localization.getText("$Loading$")%>...</div>
<div id="overlay"></div>
<div class="wrapper">
	<div class="section hasgradient">
		<div class="content">
			<!--innerbox -->
			<div class="innerbox">
				<div class="title">
					<div class="alignright" >
                        <div class="createAdaptorsCollection" style="width:70px; height:15px; margin-right:17px;"><span style="padding-left:20px;"><%=CardioLog.API.Localization.getText("$Add$")%></span>
		                    <ul>
                                <%if (CardioLog.API.ProductLicense.ProductFeatures.IsValidYammerAdaptor) { %>
			                    <li onclick="addYammerAdaptor();">Yammer</li>
                                <%} %>
                                <%if (CardioLog.API.ProductLicense.ProductFeatures.IsValidSitrionAdaptor) { %>
                                <li onclick="addSitrionAdaptor();">Sitrion</li>
                                <%} %>
		                    </ul>
	                    </div>
                    </div>
                    </div>
                    <div class="surveytable seotable">
					<br />
					<table cellpadding="0" cellspacing="0" border="0" id="jobs">
						<thead>
							<tr>
								<th align="left" class="th-padd" style="padding-left:10px;"><%=CardioLog.API.Localization.getText("$Type$")%></th>
                                <th align="left"><%=CardioLog.API.Localization.getText("$Created$")%></th>
                                <th align="left"><%=CardioLog.API.Localization.getText("$Last Runtime$")%></th>
                                <th align="left"><%=CardioLog.API.Localization.getText("$Status$")%></th>
								<th>&nbsp;</th>
							</tr>
						</thead>
						<tbody id="jobstable">
						</tbody>
					</table>
				</div>
			</div>
		</div>
	</div>
</div>
<!-- /wrapper -->
<div class="overly" id="overly" style="display:none;"></div>
    </form>

<script type="text/javascript">
    var socialAdaptors = null;
    var pagecaption = '<%=CardioLog.API.Localization.getText("$Social Adaptor$")%>';

    function formattimestamptodatetime2(timestamp) {
        if (typeof (timestamp) == "undefined" || !timestamp) return "Never";
        function lpad(v) {
            v = v + "";
            return ((v.length == 1) ? "0" : "") + v;
        }
        var months = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"];
        var t = new Date(parseInt((timestamp + "").replace(/[^0-9]/g, ""), 10));
        return lpad(eval(t.getMonth() + 1)) + "/" + lpad(t.getDate()) + "/" + t.getFullYear() + " " + lpad(t.getHours()) + ":" + lpad(t.getMinutes());
    }

    function drawAdaptors() {
        var recheck = false;

        $("#jobstable > tr").remove();

        if (socialAdaptors.length == 0)
            $("#jobs").hide();
        else
            $("#jobs").show();

        for (var i = 0; i < socialAdaptors.length; i++) {
            var type = socialAdaptors[i].type;
            var lastrun = formattimestamptodatetime2(socialAdaptors[i].lastrun);
            var created = formattimestamptodatetime2(socialAdaptors[i].created)

            if (type == "Yammer") {
                var href = "YammerAdaptor.aspx";
            }
            else if (type == "Sitrion") {
                var href = "SitrionAdaptor.aspx";
            }

            $("#jobstable").append('<tr>' +
					'	<td><h3><a href="' + href + '">' + socialAdaptors[i].type + '</a></h3></td>' +
                    '	<td>' + created + '</td>' +
                    '	<td>' + lastrun + '</td>' +
                    '	<td>' + socialAdaptors[i].status + '</td>' +
					'</tr>');
        }
        if (recheck) {
            window.setTimeout(reloadpage, 10000);
        }
    }

    function reloadpage() {
        var webflag = "";
        document.location.href = "index.aspx" + webflag;
    }

    $(window).load(function () {
        socialAdaptors = $.evalJSON($('#<%=hdnAdaptors.ClientID%>').val());
        drawAdaptors();

        $("div.createAdaptorsCollection").styledButton({
            'padding': '5px 20px',
            'font-size': '14px',
            'orientation': 'left',
            'dropdown': { 'element': 'ul' },
            'role': 'select',
            'defaultValue': 'default value',
            'name': 'adaptors',
            'clear': true
        });
    });

    parent.setCaption('Administration', false, pagecaption);

</script>
</body>
</html>
