<%@ page language="c#" inherits="_reports, CardioLog_deploy" %>
<%@ Import Namespace="CardioLog.API" %>
<% 
    string cardioLogUIVersion = CardioLog.API.CardioLogUIVersion.UIVersion;
    //private bool hasViewPermissions()
    //{
    //    CardioLog.API.sp
    //    bool canView = false;
    //    return canView;
    //}
%>

<html>
	<head>
        <meta http-equiv="X-UA-Compatible" content="IE=EmulateIE9">
		<TITLE>CardioLog(TM) - Web analytics for the enterprise portal - Intlock Ltd.</TITLE>
        <!-- required by qBubble -->
        <script type="text/javascript" src="/Cardiolog/Scripts/jquery1.7.js"></script>
        <script type="text/javascript" src="/Cardiolog/Scripts/general.aspx"></script>
        <!-- /required by qBubble -->
   
		<%if(cardioLogUIVersion == "2007")
        { %>
            <LINK rel="stylesheet" type="text/css" href="/CardioLog/Styles/general.css"></LINK>
        <%} %>
	    <%if (cardioLogUIVersion == "2010" || cardioLogUIVersion == "2013") 
        { %>
            <LINK rel="stylesheet" type="text/css" href="/CardioLog/Styles/2010_general.css"></LINK>
        <%} %>
		<style>
			* {
				font-family:Arial;
				font-size:14px;
				font-weight:regular;
				color:#2254B1;
			}
		</style>
         
        <%--<%if (CardioLog.API.Util.GetWebConfigAppSettingsValue("SharePointFeatureSecured").ToLower() == "true"
        && (Request.UrlReferrer == null || Request.UrlReferrer.ToString() != Request.Url.Query.Substring(1)))
          //Response.Redirect("/CardioLog/CustomError.aspx?err=Permission Denied&message=You do not have permissions to view this report.");
        {%>
        <script>
            if (window.opener == null
                || location.search != "?" + window.opener.location.href) {
                location.href = "/CardioLog/CustomError.aspx?err=Permission Denied&message=You do not have permissions to view this report."
            }
        </script>              
        <%}%>--%>
		<script>
		    function getPosition() {
		        var pos = { x: 0, y: 0 };
		        var obj = document.getElementById("mainFrame");
		        if (obj != null) {
		            while (obj.tagName.toUpperCase() != "BODY") {
		                pos.x += obj.offsetLeft;
		                pos.y += obj.offsetTop;
		                obj = obj.offsetParent;
		            }
		        }
		        return pos;
		    }
		    function hideAvailableReportDates() {
		        document.getElementById("pleaseWait").style.display = "none";
		        document.getElementById("reportsContainer").style.display = "";
		    }
		    function hidePleaseWait() {
		        if (document.getElementById("reportContainer").readyState == "complete") {
		            document.getElementById("pleaseWait").style.display = "none";
		            document.getElementById("reportsContainer").style.display = "";
		        }
		    }
		    function parsePossibleTemplates(xml) {
		    	var selectField = document.getElementById("reportsSelect");
		        if (xml.readyState == 4) {
		            document.getElementById("reportContainer").onload = hidePleaseWait;
		            document.getElementById("reportContainer").onreadystatechange = hidePleaseWait;
		            var templates = new Array();
		            var validString = xml.responseXml.text.replace(/&amp;/g, '&');
		            var pairs = validString.split(";");
		            for (var i = 0; i < pairs.length; i++) {
		                if (pairs[i] == "") continue;
		                var template = {};
		                pairs[i].replace(/\'([^\']*)\',\'([^\']*)\'/, function (a, b, c) {
		                    template.name = c;
		                    template.id = b;
		                });
		                templates.push(template);
		            }
		            if (templates.length == 0) {
		            	$(".loadingReport").text("Could not find reports for this url");
		            } else {
		                if (templates.length == 1) {
		                    document.getElementById("reportChooser").style.display = "none";
		                    document.getElementById("reportContainer").src = "/CardioLog/CLReport/ContextBasedReport.aspx?templateId=" + templates[0].id + "&url=" + url + "&availableWidth=" + (parseInt(document.body.offsetWidth, 10) - 100);
		                    //document.getElementById("reportContainer").style.height = parseInt(document.body.offsetHeight, 10) - 100 + "px";
		                } else {
		                	// Sort the templates.
		                	templates.sort(function (a, b) {
		                		var upA = a.name.toUpperCase();
		                		var upB = b.name.toUpperCase();
		                		return (upA < upB) ? -1 : (upA > upB) ? 1 : 0;
		                	});
		                	
		                    for (var i = 0; i < templates.length; i++) {
		                        if (i == 0) {
		                            document.getElementById("reportContainer").src = "/CardioLog/CLReport/ContextBasedReport.aspx?templateId=" + templates[i].id + "&url=" + url + "&availableWidth=" + (parseInt(document.body.offsetWidth, 10) - 100);
		                        }
		                        var option = document.createElement("option");
		                        option.value = templates[i].id;
								// Milen: Next line is a temporary solution and should be replaced by a default property because id may change
		                        if (option.value == "00000000-0000-0000-0000-000000000000")
		                        	option.selected = 'selected';
		                        option.innerHTML = templates[i].name.replace(/&/g, "&amp;");
		                        selectField.appendChild(option);
		                    }
		                }
		            }
		        }
		        loadReport(selectField);
		    }

		    function loadReport(select) {
		        document.getElementById("pleaseWait").style.display = "";
		        document.getElementById("reportContainer").src = "/CardioLog/CLReport/ContextBasedReport.aspx?templateId=" + select.options[select.selectedIndex].value + "&url=" + url + "&availableWidth=" + (parseInt(document.body.offsetWidth, 10) - 100);
		        document.getElementById("pleaseWait").focus();
		    }

		    function retrieveTemplates(url, callback) {
		        ddCallback = callback;
		        var path = "/cardiolog/CLReport/ContextBasedReportWS.asmx/getPublishedTemplatesByUrl"
		        var ddXml = new ActiveXObject("Microsoft.XMLHTTP");
		        ddXml.Open("POST", path, true);
		        ddXml.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
		        ddXml.onreadystatechange = function () { parsePossibleTemplates(ddXml) };
		        ddXml.Send("url=" + url);
		    }

		    var url = '<%= cleanInternalParams() %>';

		    retrieveTemplates(url);
		</script>
	</head>
	<%if(cardioLogUIVersion == "2007")
    { %>
    <body style="margin:0px; padding:0px;" scroll="no">
    <table id="pleaseWait" border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
		<TR>
			<TD class="headerBG" valign="center" colspan="2">
				<TABLE cellpadding="0" cellspacing="0" border="0" width="100%">
					<TR>
						<td width="100%" style="padding-left:5px;"><IMG src="images/cardiologTitle.gif"></TD>
						<TD align="right" valign="bottom"></TD>
					</TR>
				</TABLE>
			</TD>
		</TR>
		<TR>
			<TD class="sectionTitleBG sectionTitleText" valign="center" id="clpageCaption" nowrap="true" width="100%">&nbsp;</TD>
			<td style="display:; width:312px;" class="sectionTitleBG sectionTitleText" align="right" nowrap="true">
			</td>
		</TR>
		<tr><td align="center" valign="middle" id="message" class="loadingReport" colspan="2" class="reportTitle"><img src="reportsLoading.gif" align="absmiddle" /> <img src="/CardioLog/images/messages/pleaseWait.gif" /></td></tr>
	</table>
	<TABLE id="reportsContainer" cellpadding="0" cellspacing="0" border="0" width="100%" height="100%" style="z-index:1; display:;">
		
        <TR>
			<TD class="headerBG" valign="center" colspan="2">
				<TABLE cellpadding="0" cellspacing="0" border="0" width="100%">
					<TR>
						<td width="100%" style="padding-left:5px;"><IMG src="images/cardiologTitle.gif"></TD>
						<TD align="right" valign="bottom"></TD>
					</TR>
				</TABLE>
			</TD>
		</TR>
		<TR>
			<TD class="sectionTitleBG sectionTitleText" valign="center" id="clpageCaption" nowrap="true" width="100%">&nbsp;</TD>
			<td id="reportChooser" style="width:312px;" class="sectionTitleBG sectionTitleText" align="right" nowrap="true">
				<nobr class="sectionTitleText">Choose report: <select id="reportsSelect" class="inputSelect" style="width:200px;" onchange="loadReport(this);"></select></nobr>
			</td>
		</TR>
		<TR>
			<TD width="100%" height="100%" colspan="2">
				<iframe id="reportContainer" style="width:100%; height:100%;" frameborder="0" src="about:blank"></iframe>
			</td>
		</tr>        
	</table>
    </body>
    <% } %>
    <%if (cardioLogUIVersion == "2010" || cardioLogUIVersion == "2013")
    { %>
    <body class="mainBODY reportBODY" scroll="no" style="background-color:#efebef;">
    <table id="pleaseWait" border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
		<tr class="2010_headerBG">
    		<td width="100%" colspan="3">
			    <table width="100%" border="0" cellpadding="0" cellspacing="0">	
			        <TR >
					    <td><IMG src="/CardioLog/images/2010/TopBarLeft.gif" /></td>
					    <TD align="right"><IMG src="/CardioLog/images/2010/TopBarRight.gif" style="cursor:hand" onclick="window.open('http://server.iad.liveperson.net/hc/51729920/?cmd=file&file=visitorWantsToChat&site=51729920&byhref=1&imageUrl=http://www.intlock.com/intlocksite/images/LivePerson/general-3');"/></TD>
			        </TR>
			    </table>
			</td>
		</tr>
		<tr>
            <TD><IMG src="/CardioLog/images/2010/MainTopTopLeft.gif"></TD>
            <TD style="BACKGROUND-IMAGE: url(/CardioLog/images/2010/MainTopTopBG.gif); BACKGROUND-REPEAT: repeat-x; BORDER-TOP: #acacac 1px solid; WIDTH: 100%;" align=right>
            <TD align=right><IMG src="/CardioLog/images/2010/MainTopTopRight.gif"></TD>
        </tr>
        <tr>
        <td align="center" valign="middle" class="loadingReport" colspan="3" width="100%" height="100%" style="border-left:solid 1px #acacac; border-right:solid 1px #acacac; filter:progid:DXImageTransform.Microsoft.Gradient(GradientType=0, StartColorStr='#efebef', EndColorStr='#ffffff')">
			<img src="/CardioLog/Images/loadingReport.gif"><p />
			<%=CardioLog.API.Localization.getText("$Loading report, please wait$")%>...
        </td>
        </tr>
        <tr valign="bottom">		
            <td style="background-image:url(/CardioLog/images/2010/LeftWhiteBarBottomLeft.gif); background-repeat:repeat-x;">&nbsp;</td>
            <td colspan="2" style="background-image:url(/CardioLog/images/2010/LeftWhiteBarBottomMiddle.gif); background-repeat:repeat-x; width:100%" align="right" valign="top"><img src="/CardioLog/images/2010/LeftWhiteBarBottomRight.gif"/></td>
        </tr>
    </table>
    <table id="reportsContainer" width="100%" border="0" cellpadding="0" cellspacing="0" style="margin: 0;">
	    <tr class="2010_headerBG">
    		<td width="100%" colspan="3">
			    <table width="100%" border="0" cellpadding="0" cellspacing="0">	
			        <TR >
					    <td><IMG src="/CardioLog/images/2010/TopBarLeft.gif" /></td>
					    <TD align="right"><IMG src="/CardioLog/images/2010/TopBarRight.gif" style="cursor:hand" onclick="window.open('http://server.iad.liveperson.net/hc/51729920/?cmd=file&file=visitorWantsToChat&site=51729920&byhref=1&imageUrl=http://www.intlock.com/intlocksite/images/LivePerson/general-3');"/></TD>
			        </TR>
			    </table>
			</td>
		</tr>
	</table>
	<table id="container" border="0" cellpadding="0" cellspacing="0" width="100%" height="92%">
        <tr>
            <td style="BACKGROUND-IMAGE: url(/CardioLog/images/2010/MainTopTopLeft.gif); BACKGROUND-REPEAT: repeat-x;">
                &nbsp;
            </td>
            <TD style="BACKGROUND-IMAGE: url(/CardioLog/images/2010/MainTopTopBG.gif); BACKGROUND-REPEAT: repeat-x; BORDER-TOP: #acacac 1px solid; width: 100%; margin:0; padding:0;" id=templateTD>
                <div id="reportChooser" style="display:inline-block; float:right;">
                    <span class="sectionTitleTextBlack" style="margin-bottom: 2px; display:inline-block;">Template: </span>
                    <span style="PADDING-LEFT: 5px" width="200px">
                        <select id="reportsSelect" class="inputSelect" style="width:200px;" onchange="loadReport(this);"></select>
                    </span>
                </div>
            </TD>
            <td style="BACKGROUND-IMAGE: url(/CardioLog/images/2010/MainTopTopRight.gif); BACKGROUND-REPEAT: repeat-x;">
                &nbsp;
            </td>
        </tr>
        <tr>
			<td width="100%" height="92%" colspan=3 style="border-left:solid 1px #acacac; border-right:solid 1px #acacac">
				<iframe id="reportContainer" style="width:100%; height:100%;" frameborder="0" src="about:blank"></iframe>
			</td>
		</tr>
        <tr valign="bottom">
            <td style="background-image:url(/CardioLog/images/2010/LeftWhiteBarBottomLeft.gif); background-repeat:repeat-x;">&nbsp;</td>
            <td colspan="2" style="background-image:url(/CardioLog/images/2010/LeftWhiteBarBottomMiddle.gif); background-repeat:repeat-x; width:100%" align="right" valign="top"><img src="/CardioLog/images/2010/LeftWhiteBarBottomRight.gif"/></td>
        </tr>
    </table>
   
    </body>
   <% } %>
   <!-- needed for tooltips(help bubbles) to work -->
   <div class="qbubble" id="qbubble"><div class="qtop"></div><div class="qmid"><div class="qtext" id="qtxt"></div></div><div class="qbot"></div></div>
</html>